; The infinite Tower v1.0 by Thibaut Chevalier
; copyright 23/04/2002


;== Game's variables ==
_textshadow             = $c0f9
player_state            = _textshadow
player_side             = _textshadow+1
player_y_coord          = _textshadow+2
player_x_coord          = _textshadow+3
player_walk             = _textshadow+4
int_counter             = _textshadow+5
get_key_pb_counter      = _textshadow+6
fall_message            = _textshadow+7
vertical_speed          = _textshadow+8
top_block_y_coord       = _textshadow+9
y_platform_left         = _textshadow+10
x_platform_left         = _textshadow+11
y_platform_middle       = _textshadow+12
x_platform_middle       = _textshadow+13
y_platform_right        = _textshadow+14
x_platform_right        = _textshadow+15
score                   = _textshadow+16  ; word
power_bar_status        = _textshadow+18
power_bar_counter       = _textshadow+19  ; word
temporary               = _textshadow+21  ; word
temporary_2             = _textshadow+23  ; word
temporary_3             = _textshadow+25  ; word


;== Aliases ==
power_bar_delay = 2600

_getkey         = $55aa
GET_KEY         = $5371
K_ENTER         = $09       ; Enter
K_EXIT          = $37       ; exit
K_DOWN          = $01       ; Down
K_LEFT          = $02       ; Left
K_RIGHT         = $03       ; Right
K_UP            = $04       ; Up
K_SECOND        = $36
K_F5            = $31
K_F4            = $32       
K_F3            = $33
K_F2            = $34
K_F1            = $35
K_NOKEY         = $00       ; no key
K_PLUS          = $0A       ; +
K_MINUS         = $0B       ; -
K_CLEAR         = $0F       ; Clear

Delta           = (0CA00h - 0FC00h) / 100h                ; Diffrence between the 2 gray pages / 100h
_asm_exec_ram   = $d748
GrayMem1        = $fc00
GrayMem2        = $CA00
VIDEO_MEM       = $fc00
_plotSScreen    = 0C9FAh    ; graph mem
_runindicoff    = $4ab1
_runindicon     = $4aad
_pause          = $4d43
_penCol         = $c37c
_penRow         = $c37d
_vputs          = $4aa5
_vputmap        = $4aa1     ; display variable width character (A=char)
_OP1            = $c089
_getkey         = $55aa
_flushallmenus  = $49dc   ; clear the menu key stacks
_ldhlhl         = $5928   ; move the contents of (hl) into hl
_mul_hl         = $4547   ; multiply h and l
_cphlde         = $403C
_SET_ABS_SRC_ADDR   = $4647
_SET_ABS_DEST_ADDR  = $5285
_SET_MM_NUM_BYTES   = $464f
_MM_LDIR            = $52ed
_EX_AHL_BDE         = $45f3
_ahl_Plus_2_Pg3     = $4c3f
_asapvar            = $0d6fc   ; name of the current asm prog
_ldhlz              = $437b    ; write b zeros to (hl)
_clrScrn            = 4A82h    ; clear LCD screen and _textShadow

delta           = ($0ca00 - $0fc00) / $100       ; Diffrence between the 2 gray pages / $100


.org _asm_exec_ram

    nop
    jp ProgStart
    .dw 0
    .dw ShellTitle

ShellTitle:
    .db "The infinite Tower v1.0",0

ProgStart:
    xor a
    ld (player_walk), a
    
    call _flushallmenus
    call _runindicoff
    
    call OpenGray
    call CloseGray  ; don't ask me why, the interrupt doesn't start the first time
    call OpenGray
    
return_from_game:
    xor a
    ld (player_walk), a
    call ClearPage1
    
    call draw_8tower_n_lines
    
return_from_highscores:    
    call clear_zone_between_lines
    ld hl, options_string
    call text_sequence
    
    ld a, (screen_saving+1) ; first x coordonate
    or a
    jr nz, just_before_menu_loop ; there's a game saved
    
    ld hl, $fe40
    ld de, $cc40
    ld b, 80
light_gray_text:
    ld a, (de)
    ld c, a
    ld a, (hl)
    ld (hl), c
    ld (de), a
    inc de
    inc hl
    djnz light_gray_text
    
just_before_menu_loop:
    call GET_KEY        ; avoid immediate exit if exit has been pressed during the game
    
menu_loop:
    call GET_KEY
    cp K_F2
    jp z, display_platforms_with_table
    cp K_F3
    jp z, highscores_display
    cp K_F4
    jp z, help
    cp K_F5
    jp z, end_of_the_prog
    cp K_EXIT
    jp z, end_of_the_prog
    cp K_F1
    jr nz, menu_loop
    
    call ClearPage1
    
    ld de, player_state
    ld hl, initialization
    ld bc, 20
    ldir
       
    call save_background
    
    ld hl ,power_bar_delay
    ld (power_bar_counter), hl
        
    ld d, 0
    call draw_wall
    ld d, 90
    call draw_wall
    
    ld hl, platform_table_initialization
    ld de, screen_saving
    ld bc, 24
    ldir
    
    ld bc, 57
    call draw_plateform
    call draw_plateform
    call draw_plateform
    call draw_plateform
        
    ld bc, (40<<8)+42
    call draw_plateform
    ld bc, (65<<8)+30
    call draw_plateform
    ld bc, (60<<8)+20
    call draw_plateform
    ld bc, (30<<8)+2
    call draw_plateform
    ld bc, (8<<8)+22
    call draw_plateform
    
    ld de, $fc0c
    ld hl, infinity_pic
    call draw_graphics
    
    ld de, $fd2c
    ld hl, score_pic
    call draw_graphics
    
    ld bc, (32<<8)+103
    ld (_penCol), bc
    ld hl, 0
    call display_hl     ; display score = 00000
    
    ld de, $feac
    ld hl, power_pic
    call draw_graphics
    
    ld d, 15
    call draw_lines
    ld d, 39
    call draw_lines    
    
    call initialize_power_bar
    
loop:    
    ld a, (fall_message)
    or a
    jr nz, falll
    
    ld a,%01111101
    out (1),a
    in a,(1)
    bit 6, a
    jp z, save_game_and_exit
    
    ld a,%00111111
    out (1),a
    in a,(1)
    rla
    jp nc, pause_the_game
    rla
    jp nc, back_to_menu
    rla
    jp nc, change_power_bar_status      ; checking for keys...
    
    ld a, (power_bar_status)
    dec a
    jr z, loop
    ld hl, get_key_pb_counter
    dec (hl)
    jr nz, loop
    ld (hl), 50
    ld a, (power_bar_status)
    inc a
    ld (vertical_speed), a
    call initialize_power_bar
    
;== jump ==
    ld hl, vertical_speed
    ld b, (hl)
loop_at_variable_vertical_speed:
    ld a, b
    cp 4
    call z, smoother_jump
    cp 2
    call z, smoother_jump
    ld (hl), b
loop_at_constant_vertical_speed:
        ld hl, player_y_coord
        ld a, (hl)
        cp 6
        call z, slide_screen
        dec (hl)
        ld hl, vertical_speed
        call wait_hl_time        ; this routine doesn't destroy b
        djnz loop_at_constant_vertical_speed
    ld b, (hl)                  ; hl = vertical_speed
    djnz loop_at_variable_vertical_speed
    
falll:
    call initialize_power_bar
    ld bc, (player_y_coord)
    call ground_detection
    
    ld hl, vertical_speed
    ld (hl), 1
loop_at_variable_vertical_speed_down:
    ld b, (hl)    
loop_at_constant_vertical_speed_down:
       push bc
        
        ld hl, player_y_coord
        inc (hl)
        ld a, (hl)
        cp 56
        jr nc, wrong_detection

        ld bc, (player_y_coord)
        call ground_detection
        ld b, %00000011
        ld a, d
        and b
        cp b
        jr z, ground_detected  ; ground detected
        ld b, %11000000
        ld a, d
        and b
        cp b
        jr z, ground_detected  ; ground detected
wrong_detection:
        ld a, (player_y_coord)
        cp 62
        jp z, you_ve_lost
        
        ld hl, vertical_speed
        call wait_hl_time
       pop bc
       djnz loop_at_constant_vertical_speed_down
    ld a, (hl)                   ; hl = vertical speed
    cp 7
    jr z, loop_at_variable_vertical_speed_down
    inc (hl)
    cp 1
    jr z, smoother_fall
    cp 3
    jr nz, loop_at_variable_vertical_speed_down
smoother_fall:
    inc (hl)
    jr loop_at_variable_vertical_speed_down
    
wait_hl_time:
    ld e, b
    ld a, 9
    ld b, (hl)  ; djnz counter
    sub b
    ld b, a
wait_hl_time_loop:
    halt
    djnz wait_hl_time_loop
    ld b, e     ; restore b
    ret  
    
smoother_jump:
    dec b
    ret

ground_detected:            ; check if it is not a false ground
    ld bc, (player_y_coord)
    ld a, 7
    add a, c
    ld d, a
    ld e, b
    dec e
    call FindPixel
    ld c, a             ; save the bit mask
    and (hl) ; and the byte on the 1st gray page
    jr nz, other_side   ; dark gray or black pixel, check on the other side
    
    ld a, delta; on this part of the code, the pixel at the left of the guy is off on the 1st gray page
    add a, h   ;
    ld h, a    ; change of gray page
    ld a, c    ; restore the bit mask
    and (hl)
    jr nz, launch_vertical_loop
other_side
    ld bc, (player_y_coord)
    ld a, 7
    add a, c
    ld d, a
    ld a, 8
    add a, b
    ld e, a
    call FindPixel
    ld c, a                  ; save the bit mask
    and (hl)                 ; save the byte on the 1st gray page
    jr nz, correct_detection ; dark gray or black pixel, check on the other side
    
    ld a, delta; on this part of the code, the pixel at the right of the guy is off on the 1st gray page
    add a, h   ;
    ld h, a    ; change of gray page
    ld a, c    ; restore the bit mask
    and (hl)
    jr nz, launch_vertical_loop     ; else the detection is correct
    
correct_detection:
    xor a
    ld (fall_message), a
    ld (vertical_speed), a
    pop bc
    jp loop

launch_vertical_loop:
    dec d
    call FindPixel
    ld c, a         ; save the bit_mask
    ld b, (hl)
    ld a, delta; 
    add a, h   ;
    ld h, a    ; change of gray page
    ld a, (hl)
    or b
    and c
    jr z, correct_detection     ; white pixel detected = correct detection
    
    call FindPixel
    ld c, a         ; save the bit_mask
    ld b, (hl)
    and c
    jr z, launch_vertical_loop
    ld a, delta; 
    add a, h   ;
    ld h, a    ; change of gray page
    ld a, (hl)
    and c
    jp z, wrong_detection     ; dark gray pixel detected = wrong detection
    
    jr launch_vertical_loop

ground_detection:
    ld e, b
    ld a, 8
    add a, c
    ld d, a
    ld a, %00000111
    and b
    ld b, a
    call FindPixel
    
    ld d, (hl)
    inc hl
    ld e, (hl)
    
    ld a, delta ;
    add a, h    ;
    ld h, a     ; Change of gray page
    ld a, (hl)
    and e
    ld e, a     ; keep only the BLACK pixels
    dec hl
    ld a, (hl)
    and d
    ld d, a     ; keep only the BLACK pixels

    ld a, b
    or a
    ret z
slide_loop:
    sla e
    rl d
    djnz slide_loop
    ret                 ; the byte under the player is in d
      
        
;== Subroutines ==

;---------------------------------
change_power_bar_status:
    ld hl, (power_bar_counter)
    dec hl
    ld (power_bar_counter), hl
    ld a, h
    or l
    jp nz, loop
    ld hl, power_bar_delay
    ld (power_bar_counter), hl
    call inc_power_bar_status
    jp loop
;---------------------------------        
inc_power_bar_status:
    ld hl, power_bar_status
    ld a, (hl)
    cp 7
    call z, initialize_power_bar
    ld hl, power_bar_status
    ld b, (hl)
    inc (hl)
    ld c, 5
    xor a
position_in_the_power_bar:
    add a, c
    djnz position_in_the_power_bar
    ld b, 97-5
    add a, b
    ld b, a
    ld c, 57
    ld hl, High_Power
    jp GraySpriteClip
;---------------------------------
    
;---------------------------------
draw_wall:
    ld b, 9
    ld a, (top_block_y_coord)
    ld c, a
draw_wall_djnz:
    ld e, b     ; save the djnz counter in c
    ld b, d
    push bc
    push de
    ld hl, Wall
    ld a, c
    add a, 8
    cp 63+8
    call c, GraySpriteClip
    pop de
    pop bc
    ld a, 8
    add a, c
    ld c, a     ; go to the next block row
    ld b, e     ; restore the djnz counter
    djnz draw_wall_djnz 
    ret
;---------------------------------

;---------------------------------
initialize_power_bar;
    ld hl, power_bar_status
    ld (hl), 1
    ld b, 6
    ld d, 97
draw_power_djnz:
    ld e, b     ; save the djnz counter in e
    ld b, d
    ld c, 57
    push bc
    push de
    ld hl, Low_Power
    call GraySpriteClip
    pop de
    pop bc
    ld a, 5
    add a, d
    ld d, a     ; go to the next block row
    ld b, e     ; restore the djnz counter
    djnz draw_power_djnz
    ret
;---------------------------------

;---------------------------------
save_background:
    ld hl, player_y_coord
    ld d, (hl)
    inc hl
    ld e, (hl)
    call FindPixel      ; hl is the adress of the first byte to save
   push hl
    ld de, Background_Sprite
    ld a, l
    ld (de), a
    inc de
    ld a, h
    ld (de), a
    inc de
    
    call one_layer_storage_loop
   pop hl
    ld a, h
    add a, Delta            ; change gray page
    ld h, a
    call one_layer_storage_loop    
    ret

one_layer_storage_loop:
    ld a, 8
a_storage_loop:
    ldi
    ldi
    ld bc, 14
    add hl, bc
    dec a
    jr nz, a_storage_loop
    ret

Background_Sprite:
    .dw 0        ; adress in the video ram of the first byte to restore
    .db %00000000, %00000000
    .db %00000000, %00000000
    .db %00000000, %00000000
    .db %00000000, %00000000
    .db %00000000, %00000000
    .db %00000000, %00000000
    .db %00000000, %00000000
    .db %00000000, %00000000
    .db %00000000, %00000000
    .db %00000000, %00000000
    .db %00000000, %00000000
    .db %00000000, %00000000
    .db %00000000, %00000000
    .db %00000000, %00000000
    .db %00000000, %00000000
    .db %00000000, %00000000
    
restore_background:
    ld hl, Background_Sprite
    ld e, (hl)
    inc hl
    ld d, (hl)         ; get the destination adress in de :)
    inc hl
   push de
    call one_layer_restorage_loop
   pop de
    ld a, d
    add a, Delta            ; change gray page
    ld d, a
    call one_layer_restorage_loop
    ret
    
one_layer_restorage_loop:
    ld a, 8
a_restorage_loop:
    ldi
    ldi
    ex de, hl
    ld bc, 14
    add hl, bc
    ex de, hl
    dec a
    jr nz, a_restorage_loop
    ret
;---------------------------------

;---------------------------------
draw_plateform:
    push bc
    ld hl, Plateform_left
    call GraySpriteClip
    pop bc
    ld a, 8
    add a, b
    ld b, a
    push bc
    ld hl, Plateform_middle
    call GraySpriteClip
    pop bc
    ld a, 8
    add a, b
    ld b, a
    push bc
    ld hl, Plateform_right
    call GraySpriteClip
    pop bc
    ld a, 8
    add a, b
    ld b, a
    ret
;---------------------------------

;---------------------------------    
slide_screen:    
    push bc
    
    xor a
    ld (player_walk), a
    
    ld hl, $ffe0
    ld de, $fff0
    call slide_loop_call
    ld hl, $cde0
    ld de, $cdf0
    call slide_loop_call
    
    ld hl, $fc00
    ld de, $fc01
    ld bc, 11
    ld (hl), 0
    ldir
    ld hl, $ca00
    ld de, $ca01
    ld bc, 11
    ld (hl), 0
    ldir
    
    ld hl, top_block_y_coord
    ld a, (hl)
    or a
    jr nz, normal_block
    ld a, -8
normal_block:
    inc a
    ld (hl), a
    ld c, a
    ld hl, Wall
    ld b, 0
    call GraySpriteClip
    ld a, (top_block_y_coord)
    ld c, a
    ld hl, Wall
    ld b, 90
    call GraySpriteClip

    ld hl, Background_Sprite
    ld a, 16
    add a, (hl)
    ld (hl), a
    ld a, 0
    adc a, a
    inc hl
    add a, (hl)
    ld (hl), a  
    
    ld hl, y_platform_left-2
    ld b, 3
inc_loop:
    inc hl
    inc hl
    inc (hl)
    djnz inc_loop
    
    ld hl, screen_saving
    ld b, 12
platform_y_inc_loop
    ld a, (hl)
    inc hl
    ld b, (hl)
    or a                            ; we are making "x coord -OR- y coord"
    jr z, we_have_increased_hl_only ; we have detected a (0,0) platform so we don't change its coodonates 
    dec hl                          ; back to the first (y) coordonate
    inc (hl)
    ld a, (hl)
    add a, 7
    cp 71
    jr nc, inc_hl_and_reset
    inc hl
    jr we_have_increased_hl_only
inc_hl_and_reset:
    xor a
    ld (hl), a
    inc hl
    ld (hl), a
we_have_increased_hl_only:
    inc hl
    djnz platform_y_inc_loop    ; the screen has moved ; we update all the platform's coodonates in memory, and if some have become out of the screen, we have reset them (0,0) so they won't appear in the platform drawing loop
    
    call draw_top_platforms_if_they_are_partially_on_the_screen
    
first_platform:
    ld a, (y_platform_left)
    cp 2
    jr nz, next_platform
    
    ld de, screen_saving+7
    ld hl, screen_saving+5
    ld bc, 6
    lddr
    ld hl, y_platform_left
    ld de, screen_saving
    ldi
    ldi
    
    ld hl, y_platform_left
    ld a, r
    and %00001111
    sub 30
    ld (hl), a
    inc hl
    ld a, r
    and %00000111
    add a, 8
    ld (hl), a
    
next_platform:
    
    ld a, (y_platform_middle)
    cp 2
    jr nz, next_platform2
    
    ld de, screen_saving+8+7
    ld hl, screen_saving+8+5
    ld bc, 6
    lddr
    ld hl, y_platform_middle
    ld de, screen_saving+8
    ldi
    ldi
    
    ld hl, y_platform_middle
    ld a, r
    and %00001111
    sub 48
    ld (hl), a
    inc hl
    ld a, r
    and %00000011
    add a, 34
    ld (hl), a

        
next_platform2:
    ld a, (y_platform_right)
    cp 2
    jr nz, next_platform3
    
    ld de, screen_saving+16+7
    ld hl, screen_saving+16+5
    ld bc, 6
    lddr
    ld hl, y_platform_right
    ld de, screen_saving+16
    ldi
    ldi
    
    ld hl, y_platform_right
    ld a, r
    and %00001111
    sub 30
    ld (hl), a
    inc hl
    ld a, r
    and %00000111
    add a, 58
    ld (hl), a
    
next_platform3:

    ld hl, (player_y_coord)
    inc (hl)

    ld a, 1
    ld (player_walk), a
    
    ld hl, (score)
    inc hl
    ld (score), hl
    ld bc, (32<<8)+103
    ld (_penCol), bc
    call display_hl
    
    pop bc
    ret
;---------------------------------

;---------------------------------
slide_loop_call:
    ld b, 63
screen_slide_loop:
    ld a, b
    ld bc, 12
    ldir
    ld bc, -28
    add hl, bc
    ex de, hl
    add hl, bc
    ex de, hl
    ld b, a
    djnz screen_slide_loop
    ret
;---------------------------------
      
;---------------------------------
draw_infinity:
    ld b, 14
infinity_loop:
    ld a, b
    ld bc, 4
    ldir
    ld bc, 12
    ex de, hl
    add hl, bc
    ex de, hl
    ld b, a
    djnz infinity_loop
    ret
;---------------------------------

;---------------------------------
draw_lines:
    ld e, 96
    call FindPixel
    ld a, delta     ;
    add a, h        ;
    ld h, a         ; change gray page
    call draw_line
    inc d
    call FindPixel
    call draw_line
    inc d
    call FindPixel
    ld a, delta     ;
    add a, h        ;
    ld h, a         ; change gray page
    jp draw_line
;---------------------------------

;---------------------------------
draw_line:
    ld (hl), %01111111
    ld b, 3
    inc hl
dark_gray_djnz:
    ld (hl), $ff
    inc hl
    djnz dark_gray_djnz
    ret
;---------------------------------

;---------------------------------    
display_hl:
    ld de, _OP1+5
    xor a
    ld (de), a
    ld b, 5
display_hl_djnz:
    dec de
    call $4044
    add a,'0'
    ld (de), a
    djnz display_hl_djnz
    ex de, hl
    jp _vputs
;---------------------------------

;---------------------------------
text_sequence:
    ld de, _penCol
    ldi
    ldi             ; set pen col and row
    call _vputs
    ld a, (hl)
    or a
    jr nz, text_sequence
    ret
;---------------------------------

;---------------------------------    
draw_graphics:
    push de
    call draw_infinity
    pop de
    ld a, delta
    add a, d
    ld d, a
    jp draw_infinity
;---------------------------------

;---------------------------------
you_ve_lost:
    pop bc
    xor a
    ld (player_walk), a
    call restore_background
    
    ld hl, (score)
    ld bc, highscores_table+12 ; first score's adress
    ld a, 1
    ld (temporary), a       ; temporary will be the counter (1..5)
    
find_place_loop:    
      ld a, (bc)
      ld e, a
      inc bc
      ld a, (bc)
      ld d, a         ; load bc with the score at this row of the table
      call _cphlde    ; compare user score with 1st, then 2nd... scores of the table
      jr nc, place_found   ; user has a high score !!
      ld a, (temporary)
      cp 5
      jp z, graphics_n_highscore_display
      inc a
      ld (temporary), a   ; inc counter   (go to next place in the table)
        push hl
        ld hl, 13
        add hl, bc
        ld b, h
        ld c, l         ; add 13 to bc (go to the next score)
        pop hl
      jr find_place_loop
    
place_found:            ; (temporary) is the place, now we have to slide down the end of the table
    ld h, b
    ld l, c     ; ld hl, bc
    ld bc, -13
    add hl, bc  ; hl is the source of the next ldir (next line in the table)
    ld (temporary_2), hl    ; save this adress to write the name further
    
    ld a, (temporary)
    cp 5
    jr nz, piti_jump
    ld de, nothing_to_slide  ; user has the lower score : we're just gonna write on the old lower score
    push de
    jp cut      ; it will return to "nothing to slide"
    
piti_jump:
    ld b, a
    ld a, 5
    sub b       ; do "5-position" = number of scores to save elsewhere (at (freespace))
    
    push hl
     ld h, 14
     ld l, a
     call _mul_hl
     ld b, h
     ld c, l
    pop hl
    ld de, free_space    ; de = destination for ldir
        push hl
        push bc ; save source (hl) and lenght (bc)
            ldir
        pop bc
        pop hl
    call cut
    inc hl          ; now, we've to reconstitute the end of the table
    ex de, hl       ; now the source is the data at (free_space), and destination in the hiscores table (now de)
    ld hl, free_space  ; hl = source, lenght is the same
    ldir

    ld hl, highscores_table
    ld a, '1'
rewrite_numbers_loop:
    ld (hl), a
    ld bc, 14
    add hl, bc
    inc a
    cp '6'
    jr nz, rewrite_numbers_loop ; this code rewrites positions from 1 to 7 (in the highscores_table memory)

nothing_to_slide:

    set 3,(iy+5)        ; white text on black background
    call trans_band
    ld hl, new_hs_string
    call text_sequence
    set 3,(iy+5)        ; black text on white background

    xor a
    ld (UserCounter), a
wait_loop:
    ld a, (UserCounter)
    inc a
    jr nz, wait_loop    ; wait for 255 interrupt
    
             ; just a temporary use
    ld hl, (temporary_2)
    inc hl
    inc hl
    inc hl
    ld (temporary_2), hl
error_in_the_name:
    ld hl, (temporary_2)        ; in the normal execution, it is useless but it is useful when the name is cleared
    xor a
    ld (temporary_3), a      
    ld (hl), ' '
    ld d, h
    ld e, l
    inc de
    ld bc, 7
    ldir
    
    call ClearPage1
    call draw_8tower_n_lines
    call display_hs_table
    ld h, 6
    ld a, (temporary)
    ld l, a
    call _mul_hl
    ld a, l
    add a, 23
    ld (_penRow), a
    ld a, 32
    ld (_penCol), a
    
other_character:
    ld a, '_'
    call _vputmap
    ld a, (_penCol)
    sub 4
    ld (_penCol), a
wrong_character:    
    call GET_KEY
    or a                   ; cp K_NOKEY
    jr z, wrong_character
    cp K_ENTER
    jr z, erase_the_end    ; saving finished
    cp K_CLEAR
    jp z, error_in_the_name
    sub $0a
    cp $2f-$0a
    jr nc, wrong_character
    ld hl, characters
    ld b, 0
    ld c, a     ; bc = offset
    add hl, bc  ; get adress of our character
    ld a, (hl)  ; our charcter is in the register a
    or a
    jr z, wrong_character   ; in the table, 0 means that it is not a character key
  push af
    call _vputmap           ; write the letter
    ld hl, (temporary_2)
    ld b, 0
    ld a, (temporary_3)
    ld c, a
    add hl, bc
  pop af
    ld (hl), a      ; saves the character in the hiscore table
    ld hl, temporary_3
    inc (hl)
    ld a, (hl)
    cp 8            ; if a (=temporary_3)= 8, stop to check for keys
    jr nz, other_character
    
    ld a, (_penCol) ; reset a single pixel if the eight letter was a 'I'
    ld e, a
    ld d, 25
    call FindPixel
    cpl
    and (hl)        ; reset a pixel
    ld (hl), a      ; save changes to the screen
    
enter_loop:
    call GET_KEY
    cp K_CLEAR
    jp z, error_in_the_name
    cp K_ENTER
    jr nz, enter_loop
    jr hs_getkey
    
cut:
    ld de, 12
    add hl, de      ; hl is where to save the new hiscore
    ld de, (score)
    ld (hl), e
    inc hl
    ld (hl), d      ; save current score at his place
    ret

erase_the_end:
    ld a, (temporary_3)
    ld hl, (temporary_2)
    ld b, 0
    ld c, a
    add hl, bc
erase_loop:
    ld (hl), ' '
    inc hl
    ld a, (hl)
    or a
    jr nz, erase_loop
            
highscores_display:
    ld hl, game_saving
    ld b, 45
    call _ldhlz                 ; write 45 zeros at (game_saving)
    
    call display_hs_table
    
hs_getkey:
    call GET_KEY
    cp K_EXIT
    jp z, return_from_highscores
    cp K_ENTER
    jp z, return_from_highscores
    cp K_SECOND
    jp z, return_from_highscores
    jr hs_getkey
    
graphics_n_highscore_display:
    call ClearPage1
    call draw_8tower_n_lines
    jr highscores_display
;---------------------------------
        
;---------------------------------    
display_hs_table:
    call clear_zone_between_lines
    
    ld hl, highscores_table
    ld bc, (29<<8)+25
    ld (_penCol),bc
    ld b, 5     ; DJNZ counter
    
hs_displaying_loop:
  push bc       ; save b (djnz counter)
    call _vputs     ; displays the name
    push hl
        call _ldhlhl    ; load score in hl (for display_hl)
        ld bc, (_penCol)
        ld c, 87        ; colomn of the score (b is always the row)
        ld (_penCol),bc
        call display_hl  ; displays score
    pop hl      ; load saved value of hl (pointer)
    inc hl
    inc hl          ; go to the next name (hl is the pointer)
    ld bc, (_penCol)
    ld c, 25
    ld a, 6         ; this is what we're going to add to the row
    add a, b        ; we add it
    ld b, a         ; place the result in b (because it was only in a)
    ld (_penCol), bc; save b and c values at _penCol and _PenRow adresses (add 6 to the row, and set colomn at 5)
  pop bc            ; get djnz counter
 djnz hs_displaying_loop
    ret
;---------------------------------
        
;---------------------------------   
help:
    call clear_zone_between_lines
    ld hl, help_string
    call text_sequence
    jr hs_getkey
;---------------------------------
    
;---------------------------------    
clear_zone_between_lines:
    ld hl, $fdc0
    ld (hl), 0 
    ld de, $fdc1
    ld bc, $20f
    ldir
    ld hl, $cbc0
    ld (hl), 0
    ld de, $cbc1
    ld bc, $20f
    ldir
    ret
;---------------------------------
    
;---------------------------------
pause_the_game:
    xor a
    ld (player_walk), a
    
    ld hl, $fdc0
    ld de, free_space
    ld bc, $70          ; 7 rows
    ldir                ; save data which will be destroyed
    
    call trans_band
    
    set 3,(iy+5)        ; white text on black background
    ld hl, paused_string
    call text_sequence
    res 3,(iy+5)        ; black text on white background
    
paused_loop:
    call GET_KEY
    cp K_PLUS
    call z, contrast_plus
    cp K_MINUS
    call z, contrast_minus
    or a                ; cp K_NOKEY
    jr z, paused_loop
    
    ld de, $fdc0
    ld hl, free_space
    ld bc, $70          ; 7 rows
    ldir                ; restore data which has been destroyed
    
    ld a, 1
    ld (player_walk), a
    
    jp loop
;---------------------------------    
    
;---------------------------------
contrast_plus:
    ld a, ($C008)   ; get contrast value
    inc a           ; increase it
    ld ($C008), a   ; save it in the memory
    out (2), a      ; send it to the port
    xor a           ; ld a, K_NOKEY
    ret

contrast_minus:
    ld a, ($C008)   ; same thing
    dec a           ; decrease contrast value
    ld ($C008), a
    out (2), a
    xor a           ; ld a, K_NOKEY
    ret
;-------------------------------

;-------------------------------
trans_band:
    ld hl, $fdc0
    ld b, 7
pause_band_loop:
    ld a, b
    ld d, h
    ld e, l
    inc de
    ld (hl), $ff
    ld bc, 11
    ldir
    ld bc, 5
    add hl, bc
    ld b, a
    djnz pause_band_loop
    ret
;---------------------------------

;---------------------------------
draw_8tower_n_lines:
    res 3,(iy+5)        ; black text on white background
    
    ld de, $fc14
    ld hl, infinity_pic
    call draw_graphics
    
    ld de, $fc18
    ld hl, power_pic
    call draw_graphics
    ld bc, (64<<8)+0
    ld hl, T_top
    call GraySpriteClip
    ld bc, (64<<8)+8
    ld hl, T_bottom
    call GraySpriteClip
    
    ld hl, $cb90
    ld (hl), $ff
    ld de, $cb91
    ld bc, $2f
    ldir
    
    ld hl, $fda0
    ld (hl), $ff
    ld de, $fda1
    ld bc, $f
    ldir
    
    ld hl, $cdd0
    ld (hl), $ff
    ld de, $cdd1
    ld bc, $2f
    ldir
    
    ld hl, $ffe0
    ld (hl), $ff
    ld de, $ffe1
    ld bc, $f
    ldir
    
    ld hl, the_string
    call text_sequence
    
    ret    
;---------------------------------

;---------------------------------
draw_top_platforms_if_they_are_partially_on_the_screen:
    ld bc, (y_platform_left)
    ld a, c
    add a, 7
    rlca
    call nc, draw_plateform
    ld bc, (y_platform_middle)
    ld a, c
    add a, 7
    rlca
    call nc, draw_plateform
    ld bc, (y_platform_right)
    ld a, c
    add a, 7
    rlca
    call nc, draw_plateform
    ret
;---------------------------------

;---------------------------------
line_platform:
    ld e, b
    ld d, c
    ld b, 24
line_platform_loop:
    call FindPixel
    or (hl)
    ld (hl), a
    ld c, a
    ld a, h
    add a, delta    ; change gray page
    ld h, a
    ld a, c         ; restore bit mask
    or (hl)
    ld (hl), a
    inc e
    djnz line_platform_loop
    jr plouf
    
display_platforms_with_table:
    ld a, (screen_saving+1) ; first x coordonate
    or a
    jp z, menu_loop       ; option not available
    
    call ClearPage1
    
    ld hl, variable_saving
    ld de, player_state
    ld bc, 21
    ldir
    
    ld d, 0
    call draw_wall
    ld d, 90
    call draw_wall
    
    ld a, 12
    ld (temporary), a
    ld hl, screen_saving
display_platforms_with_table_loop:
    ld c, (hl)
    inc hl
    ld b, (hl)
    inc hl
    push hl
    ld hl, temporary
    dec (hl)
    ld a, c
    add a, 7
    cp 70
    jr z, line_platform
    cp 70
    jr nc, plouf
    
    ld a, b
    or c
    call nz, draw_plateform
plouf:
    pop hl
    ld a, (temporary)
    or a
    jr nz, display_platforms_with_table_loop
    
    call draw_top_platforms_if_they_are_partially_on_the_screen
    
    ld hl, power_bar_delay
    ld (power_bar_counter), hl
            
    call save_background
    ld de, $fc0c
    ld hl, infinity_pic
    call draw_graphics
    
    ld de, $fd2c
    ld hl, score_pic
    call draw_graphics
    
    ld bc, (32<<8)+103
    ld (_penCol), bc
    ld hl, (score)
    call display_hl     ; display score
    
    ld de, $feac
    ld hl, power_pic
    call draw_graphics
    
    ld d, 15
    call draw_lines
    ld d, 39
    call draw_lines    
    
    ld a, (power_bar_status)
    push af
    call initialize_power_bar
    pop af
    dec a
    jr z, power_bar_reset    
    ld b, a
power_bar_init_loop:
    push bc
    call inc_power_bar_status
    pop bc
    djnz power_bar_init_loop    
power_bar_reset:
    
    ld a, (player_side)
    dec a
    jr z, player_R
    ld hl, Player_Left_2
    jr player_L_R
player_R:
    ld hl, Player_Right_2
player_L_R:
    ld bc, (player_y_coord)
    call GraySpriteClip
    
    jp pause_the_game               ; begin in paused_mode
    

;---------------------------------

;---------------------------------
back_to_menu:
    call save_game
    jp return_from_game
;---------------------------------

;---------------------------------
save_game:
    xor a
    ld (player_walk), a
    ld hl, player_state
    ld de, variable_saving
    ld bc, 21
    ldir                ; save all the variables of the game
    ret
;---------------------------------

;---------------------------------    
save_game_and_exit:
    call save_game

end_of_the_prog:
    ld hl,_asapvar      ; hl->name of program
    rst 20h             ; copy to OP1
    rst 10h             ; _findsym
    xor a
    ld hl,data_start-_asm_exec_ram+4        ; offset
    add hl,de                   ; hl=pointer to data in original prog
    adc a,b                     ; in case we overlapped pages
    call _SET_ABS_DEST_ADDR
    xor a                       ; no absolute addressing now
    ld hl,data_start            ; get data from here
    call _SET_ABS_SRC_ADDR
    ld hl,data_end-data_start   ; number of bytes to save
    call _SET_MM_NUM_BYTES
    call _MM_LDIR               ; copy data
    
    call ClearPage1
    call _clrScrn       ; clear LCD AND _textshadow
    call _runindicon
    jp CloseGray
      
;================== The program's execution ends here ===================
    

    

; =============================================================
; Dan Eble & James Yopp FindPixel routine
; Input:  D = y, E = x
; Output: HL= addr in vid mem, A = bitmask, C is modified
; =============================================================
FindPixel:
        ld hl,FP_Bits
        ld a,e
        and $07         ; a = bit offset
        add a,l
        ld l,a
        adc a,h
        sub l
        ld h,a
        ld c,(hl)       ; c = bitmask for (hl)
                        ; 48 t-states up to this point
        ld hl,FP_RLD
        ld (hl),d
        ld a,e          ; a = x/8 (byte offset within row)
        rrca
        rrca   
        rrca
        rld
        or $FC 
        ld l,(hl)
        ld h,a          ; hl -> byte in vid mem
        ld a,c          ; now a = bitmask for (hl)
                        ; 121 t-states up to this point
        ret

FP_RLD:  .db $00
FP_Bits: .db $80,$40,$20,$10,$08,$04,$02,$01


#include "sprite.asm"
#include "TowerInterrupt.asm"
#include "TowerSprites.asm"

:==============

characters:
    .db "xtoje",0,0," wsnid",0,0
    .db "zvrmhc",0,0,"yuqlgb",0,0,0,".pkfa"

the_string:
.db 21,8,"the", 0
.db 98,8,"v1.0", 0
.db 30,16,"by Thibaut Chevalier", 0
.db 0
options_string:
.db 36,29,"F1 - new game", 0
.db 36,35,"F2 - continue game",0
.db 36,41,"F3 - highscores", 0
.db 36,47,"F4 - help", 0
.db 36,53,"F5 - exit", 0
.db 0

help_string:
.db 3,32,"2nd - increase power", 0
.db 15,38,"more - pause", 0
.db 27,44,"exit - back to menu", 0
.db 39,50,"clear - exit and save game", 0
.db 0

paused_string:
.db 34,28,"- pause -",0,0

new_hs_string:
.db 22,28,"new highscore !",0
.db 0

data_start:
highscores_table
.db "1. --------",0,0,0
.db "2. --------",0,0,0
.db "3. --------",0,0,0
.db "4. --------",0,0,0
.db "5. --------",0,0,0

game_saving:
variable_saving:
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
screen_saving:
.db 0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0
data_end:

initialization:
    .db 0
    .db 1
    .db 49  ; y_coord
    .db 8   ; x_coord
    .db 1   ; player_walk
    .db 0
    .db 50
    .db 0
    .db 0   ; vertical_speed
    .db -5  ; top_block_y_coord
    .db -8
    .db 8   ; platform_left coordonates
    .db -20
    .db 36  ; platform_middle coordonates
    .db -10
    .db 64  ; platform_right coordonates
    .db 0,0 ; score
    
platform_table_initialization:
.db 22,8,57,0,57,72,0,0,0,0
.db 2,30,42,40,57,24,0,0
.db 20,60,30,65,57,48,0,0


free_space:

.end
